// Generated by CoffeeScript 1.12.8
(function() {
  Turbolinks.HeadDetails = (function() {
    var elementIsScript, elementIsStylesheet, elementIsTracked, elementType;

    function HeadDetails(element1) {
      var base, data, element, i, key, len, ref;
      this.element = element1;
      this.elements = {};
      ref = this.element.childNodes;
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        if (!(element.nodeType === Node.ELEMENT_NODE)) {
          continue;
        }
        key = element.outerHTML;
        data = (base = this.elements)[key] != null ? base[key] : base[key] = {
          type: elementType(element),
          tracked: elementIsTracked(element),
          elements: []
        };
        data.elements.push(element);
      }
    }

    HeadDetails.prototype.hasElementWithKey = function(key) {
      return key in this.elements;
    };

    HeadDetails.prototype.getTrackedElementSignature = function() {
      var key, tracked;
      return ((function() {
        var ref, results;
        ref = this.elements;
        results = [];
        for (key in ref) {
          tracked = ref[key].tracked;
          if (tracked) {
            results.push(key);
          }
        }
        return results;
      }).call(this)).join("");
    };

    HeadDetails.prototype.getScriptElementsNotInDetails = function(headDetails) {
      return this.getElementsMatchingTypeNotInDetails("script", headDetails);
    };

    HeadDetails.prototype.getStylesheetElementsNotInDetails = function(headDetails) {
      return this.getElementsMatchingTypeNotInDetails("stylesheet", headDetails);
    };

    HeadDetails.prototype.getElementsMatchingTypeNotInDetails = function(matchedType, headDetails) {
      var elements, key, ref, ref1, results, type;
      ref = this.elements;
      results = [];
      for (key in ref) {
        ref1 = ref[key], type = ref1.type, elements = ref1.elements;
        if (type === matchedType && !headDetails.hasElementWithKey(key)) {
          results.push(elements[0]);
        }
      }
      return results;
    };

    HeadDetails.prototype.getProvisionalElements = function() {
      var elements, key, provisionalElements, ref, ref1, tracked, type;
      provisionalElements = [];
      ref = this.elements;
      for (key in ref) {
        ref1 = ref[key], type = ref1.type, tracked = ref1.tracked, elements = ref1.elements;
        if ((type == null) && !tracked) {
          provisionalElements.push.apply(provisionalElements, elements);
        } else if (elements.length > 1) {
          provisionalElements.push.apply(provisionalElements, elements.slice(1));
        }
      }
      return provisionalElements;
    };

    elementType = function(element) {
      if (elementIsScript(element)) {
        return "script";
      } else if (elementIsStylesheet(element)) {
        return "stylesheet";
      }
    };

    elementIsTracked = function(element) {
      return element.getAttribute("data-turbolinks-track") === "reload";
    };

    elementIsScript = function(element) {
      var tagName;
      tagName = element.tagName.toLowerCase();
      return tagName === "script";
    };

    elementIsStylesheet = function(element) {
      var tagName;
      tagName = element.tagName.toLowerCase();
      return tagName === "style" || (tagName === "link" && element.getAttribute("rel") === "stylesheet");
    };

    return HeadDetails;

  })();

}).call(this);
