// Generated by CoffeeScript 1.12.8
(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  require('./renderer');

  require('./head_details');

  Turbolinks.SnapshotRenderer = (function(superClass) {
    extend(SnapshotRenderer, superClass);

    function SnapshotRenderer(currentSnapshot, newSnapshot, isPreview) {
      this.currentSnapshot = currentSnapshot;
      this.newSnapshot = newSnapshot;
      this.isPreview = isPreview;
      this.currentHeadDetails = new Turbolinks.HeadDetails(this.currentSnapshot.head);
      this.newHeadDetails = new Turbolinks.HeadDetails(this.newSnapshot.head);
      this.newBody = this.newSnapshot.body;
    }

    SnapshotRenderer.prototype.render = function(callback) {
      if (this.shouldRender()) {
        this.mergeHead();
        return this.renderView((function(_this) {
          return function() {
            _this.replaceBody();
            if (!_this.isPreview) {
              _this.focusFirstAutofocusableElement();
            }
            return callback();
          };
        })(this));
      } else {
        return this.invalidateView();
      }
    };

    SnapshotRenderer.prototype.mergeHead = function() {
      this.copyNewHeadStylesheetElements();
      this.copyNewHeadScriptElements();
      this.removeCurrentHeadProvisionalElements();
      return this.copyNewHeadProvisionalElements();
    };

    SnapshotRenderer.prototype.replaceBody = function() {
      this.activateBodyScriptElements();
      this.importBodyPermanentElements();
      return this.assignNewBody();
    };

    SnapshotRenderer.prototype.shouldRender = function() {
      return this.newSnapshot.isVisitable() && this.trackedElementsAreIdentical();
    };

    SnapshotRenderer.prototype.trackedElementsAreIdentical = function() {
      return this.currentHeadDetails.getTrackedElementSignature() === this.newHeadDetails.getTrackedElementSignature();
    };

    SnapshotRenderer.prototype.copyNewHeadStylesheetElements = function() {
      var element, i, len, ref, results;
      ref = this.getNewHeadStylesheetElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        results.push(document.head.appendChild(element));
      }
      return results;
    };

    SnapshotRenderer.prototype.copyNewHeadScriptElements = function() {
      var element, i, len, ref, results;
      ref = this.getNewHeadScriptElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        results.push(document.head.appendChild(this.createScriptElement(element)));
      }
      return results;
    };

    SnapshotRenderer.prototype.removeCurrentHeadProvisionalElements = function() {
      var element, i, len, ref, results;
      ref = this.getCurrentHeadProvisionalElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        results.push(document.head.removeChild(element));
      }
      return results;
    };

    SnapshotRenderer.prototype.copyNewHeadProvisionalElements = function() {
      var element, i, len, ref, results;
      ref = this.getNewHeadProvisionalElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        element = ref[i];
        results.push(document.head.appendChild(element));
      }
      return results;
    };

    SnapshotRenderer.prototype.importBodyPermanentElements = function() {
      var element, i, len, ref, replaceableElement, results;
      ref = this.getNewBodyPermanentElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        replaceableElement = ref[i];
        if (element = this.findCurrentBodyPermanentElement(replaceableElement)) {
          results.push(replaceableElement.parentNode.replaceChild(element, replaceableElement));
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    SnapshotRenderer.prototype.activateBodyScriptElements = function() {
      var element, i, len, ref, replaceableElement, results;
      ref = this.getNewBodyScriptElements();
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        replaceableElement = ref[i];
        element = this.createScriptElement(replaceableElement);
        results.push(replaceableElement.parentNode.replaceChild(element, replaceableElement));
      }
      return results;
    };

    SnapshotRenderer.prototype.assignNewBody = function() {
      return document.body = this.newBody;
    };

    SnapshotRenderer.prototype.focusFirstAutofocusableElement = function() {
      var ref;
      return (ref = this.findFirstAutofocusableElement()) != null ? ref.focus() : void 0;
    };

    SnapshotRenderer.prototype.getNewHeadStylesheetElements = function() {
      return this.newHeadDetails.getStylesheetElementsNotInDetails(this.currentHeadDetails);
    };

    SnapshotRenderer.prototype.getNewHeadScriptElements = function() {
      return this.newHeadDetails.getScriptElementsNotInDetails(this.currentHeadDetails);
    };

    SnapshotRenderer.prototype.getCurrentHeadProvisionalElements = function() {
      return this.currentHeadDetails.getProvisionalElements();
    };

    SnapshotRenderer.prototype.getNewHeadProvisionalElements = function() {
      return this.newHeadDetails.getProvisionalElements();
    };

    SnapshotRenderer.prototype.getNewBodyPermanentElements = function() {
      return this.newBody.querySelectorAll("[id][data-turbolinks-permanent]");
    };

    SnapshotRenderer.prototype.findCurrentBodyPermanentElement = function(element) {
      return document.body.querySelector("#" + element.id + "[data-turbolinks-permanent]");
    };

    SnapshotRenderer.prototype.getNewBodyScriptElements = function() {
      return this.newBody.querySelectorAll("script");
    };

    SnapshotRenderer.prototype.findFirstAutofocusableElement = function() {
      return document.body.querySelector("[autofocus]");
    };

    return SnapshotRenderer;

  })(Turbolinks.Renderer);

}).call(this);
